(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ng-dynamic-forms/core'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/timepicker'), require('@angular/common'), require('ngx-bootstrap/buttons'), require('ngx-bootstrap/rating'), require('angular2-text-mask')) :
    typeof define === 'function' && define.amd ? define('@ng-dynamic-forms/ui-ngx-bootstrap', ['exports', '@angular/core', '@angular/forms', '@ng-dynamic-forms/core', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/timepicker', '@angular/common', 'ngx-bootstrap/buttons', 'ngx-bootstrap/rating', 'angular2-text-mask'], factory) :
    (global = global || self, factory((global.ngDynamicForms = global.ngDynamicForms || {}, global.ngDynamicForms.ui = global.ngDynamicForms.ui || {}, global.ngDynamicForms.ui.ngxBootstrap = {}), global.ng.core, global.ng.forms, global.ngDynamicForms.core, global['ngx-bootstrap'].datepicker, global['ngx-bootstrap'].timepicker, global.ng.common, global['ngx-bootstrap'].buttons, global['ngx-bootstrap'].rating, global['angular2-text-mask']));
}(this, function (exports, core, forms, core$1, datepicker, timepicker, common, buttons, rating, angular2TextMask) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapCheckboxComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapCheckboxComponent, _super);
        function DynamicNGxBootstrapCheckboxComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapCheckboxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-checkbox",
                        template: "<div [formGroup]=\"group\" class=\"form-check\" [class.disabled]=\"model.disabled\">\n\n    <label class=\"form-check-label\">\n\n        <input type=\"checkbox\" class=\"form-check-input\"\n               [checked]=\"model.checked\"\n               [class.is-invalid]=\"showErrorMessages\"\n               [formControlName]=\"model.id\"\n               [id]=\"elementId\"\n               [indeterminate]=\"model.indeterminate\"\n               [name]=\"model.name\"\n               [ngClass]=\"getClass('element', 'control')\"\n               [required]=\"model.required\"\n               [tabindex]=\"model.tabIndex\"\n               [value]=\"model.value\"\n               (blur)=\"onBlur($event)\"\n               (change)=\"onChange($event)\"\n               (focus)=\"onFocus($event)\"/><span [innerHTML]=\"model.label\"\n                                                [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></span>\n    </label>\n\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapCheckboxComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapCheckboxComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapCheckboxComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapCheckboxComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapCheckboxComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapCheckboxComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapCheckboxGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapCheckboxGroupComponent, _super);
        function DynamicNGxBootstrapCheckboxGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        /**
         * @param {?} model
         * @return {?}
         */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.getCheckboxElementId = /**
         * @param {?} model
         * @return {?}
         */
        function (model) {
            return this.layoutService.getElementId(model);
        };
        DynamicNGxBootstrapCheckboxGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-checkbox-group",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <div class=\"btn-group\"\n         [formGroupName]=\"model.id\"\n         [id]=\"elementId\"\n         [ngClass]=\"getClass('element', 'control')\">\n\n        <label *ngFor=\"let checkboxModel of model.group\" btnCheckbox class=\"btn\" role=\"button\"\n               [class.active]=\"checkboxModel.value\"\n               [formControlName]=\"checkboxModel.id\"\n               [id]=\"getCheckboxElementId(checkboxModel)\"\n               [innerHTML]=\"checkboxModel.label\"\n               [ngClass]=\"[getClass('element', 'control', checkboxModel)]\"></label>\n    </div>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapCheckboxGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapCheckboxGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapCheckboxGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapCheckboxGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapDatePickerComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapDatePickerComponent, _super);
        function DynamicNGxBootstrapDatePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapDatePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-datepicker",
                        template: "<div [formGroup]=\"group\" class=\"input-group\">\n\n    <input bsDatepicker class=\"form-control\" #bsDatepicker=\"bsDatepicker\"\n           [autofocus]=\"model.autoFocus\"\n           [bsConfig]=\"model.getAdditional('bsConfig', {containerClass: model.getAdditional('containerClass', 'theme-green'), showWeekNumbers: model.getAdditional('showWeekNumbers', true)})\"\n           [datesDisabled]=\"model.getAdditional('datesDisabled', [])\"\n           [daysDisabled]=\"model.getAdditional('daysDisabled', [])\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxDate]=\"model.max\"\n           [minDate]=\"model.min\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [outsideClick]=\"model.getAdditional('outsideClick', true)\"\n           [outsideEsc]=\"model.getAdditional('outsideEsc', true)\"\n           [placeholder]=\"model.placeholder\"\n           [placement]=\"model.getAdditional('placement', 'bottom')\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           (bsValueChange)=\"onChange($event)\"\n           (onHidden)=\"onCustomEvent($event, 'onHidden')\"\n           (onShown)=\"onCustomEvent($event, 'onShown')\">\n\n    <div *ngIf=\"model.toggleIcon || model.toggleLabel\" class=\"input-group-append\">\n\n        <button *ngIf=\"model.toggleIcon\"\n                class=\"btn input-group-text\" type=\"button\"\n                (click)=\"bsDatepicker.toggle()\"><img [src]=\"model.toggleIcon\"/></button>\n        <button *ngIf=\"model.toggleLabel\"\n                class=\"btn input-group-text\" type=\"button\"\n                (click)=\"bsDatepicker.toggle()\">{{ model.toggleLabel }}</button>\n\n    </div>\n\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapDatePickerComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapDatePickerComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            bsDatePicker: [{ type: core.ViewChild, args: [datepicker.BsDatepickerDirective, { static: true },] }]
        };
        return DynamicNGxBootstrapDatePickerComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.customEvent;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.focus;
        /** @type {?} */
        DynamicNGxBootstrapDatePickerComponent.prototype.bsDatePicker;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapDatePickerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapDatePickerComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapFormArrayComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapFormArrayComponent, _super);
        function DynamicNGxBootstrapFormArrayComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapFormArrayComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-form-array",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <div [formArrayName]=\"model.id\" [id]=\"elementId\" [ngClass]=\"getClass('element', 'control')\">\n\n        <div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\"\n             [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\">\n\n            <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: groupModel\"></ng-container>\n\n            <dynamic-ngx-bootstrap-form-control *ngFor=\"let _model of groupModel.group\"\n                                                [context]=\"groupModel\"\n                                                [group]=\"array.at(idx)\"\n                                                [hidden]=\"_model.hidden\"\n                                                [layout]=\"layout\"\n                                                [model]=\"_model\"\n                                                [templates]=\"templates\"\n                                                [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                           getClass('element','children'), getClass('grid','children')]\"\n                                                (blur)=\"onBlur($event)\"\n                                                (change)=\"onChange($event)\"\n                                                (focus)=\"onFocus($event)\"\n                                                (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-ngx-bootstrap-form-control>\n\n            <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: groupModel\"></ng-container>\n\n        </div>\n\n    </div>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapFormArrayComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapFormArrayComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapFormArrayComponent;
    }(core$1.DynamicFormArrayComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.templates;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.customEvent;
        /** @type {?} */
        DynamicNGxBootstrapFormArrayComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormArrayComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormArrayComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapFormGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapFormGroupComponent, _super);
        function DynamicNGxBootstrapFormGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapFormGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-form-group",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <div role=\"group\" [formGroupName]=\"model.id\" [id]=\"elementId\" [ngClass]=\"getClass('element','control')\">\n\n        <dynamic-ngx-bootstrap-form-control *ngFor=\"let _model of model.group\"\n                                           [asBootstrapFormGroup]=\"true\"\n                                           [group]=\"control\"\n                                           [hidden]=\"_model.hidden\"\n                                           [layout]=\"layout\"\n                                           [model]=\"_model\"\n                                           [templates]=\"templates\"\n                                           [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                       getClass('element','children'), getClass('grid','children')]\"\n                                           (blur)=\"onBlur($event)\"\n                                           (change)=\"onChange($event)\"\n                                           (focus)=\"onFocus($event)\"\n                                           (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-ngx-bootstrap-form-control>\n    </div>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapFormGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapFormGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapFormGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.templates;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.customEvent;
        /** @type {?} */
        DynamicNGxBootstrapFormGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapInputComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapInputComponent, _super);
        function DynamicNGxBootstrapInputComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapInputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-input",
                        template: "<div [formGroup]=\"group\" [class.input-group]=\"model.prefix || model.suffix\">\n\n    <div *ngIf=\"model.prefix\" class=\"input-group-prepend\">\n        <span class=\"input-group-text\" [innerHTML]=\"model.prefix\"></span>\n    </div>\n\n    <input [attr.accept]=\"model.accept\"\n           [attr.max]=\"model.max\"\n           [attr.min]=\"model.min\"\n           [attr.multiple]=\"model.multiple\"\n           [attr.step]=\"model.step\"\n           [autocomplete]=\"model.autoComplete\"\n           [autofocus]=\"model.autoFocus\"\n           [class.form-control]=\"model.inputType !== 'file'\"\n           [class.form-control-file]=\"model.inputType === 'file'\"\n           [class.is-invalid]=\"showErrorMessages\"\n           [dynamicList]=\"model.listId\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxlength]=\"model.maxLength\"\n           [minlength]=\"model.minLength\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [pattern]=\"model.pattern\"\n           [placeholder]=\"model.placeholder\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           [spellcheck]=\"model.spellCheck\"\n           [tabindex]=\"model.tabIndex\"\n           [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\"\n           [type]=\"model.inputType\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/>\n\n    <div *ngIf=\"model.suffix\" class=\"input-group-append\">\n        <span class=\"input-group-text\" [innerHTML]=\"model.suffix\"></span>\n    </div>\n\n    <datalist *ngIf=\"model.hasList\" [id]=\"model.listId\">\n\n        <option *ngFor=\"let option of model.list$ | async\" [value]=\"option\">\n\n    </datalist>\n\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapInputComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapInputComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapInputComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapInputComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapInputComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapInputComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapInputComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapInputComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapInputComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapInputComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapInputComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapRadioGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapRadioGroupComponent, _super);
        function DynamicNGxBootstrapRadioGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapRadioGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-radio-group",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <div btnRadioGroup class=\"btn-group\" role=\"radiogroup\"\n         [formControlName]=\"model.id\"\n         [id]=\"elementId\"\n         [ngClass]=\"getClass('element', 'control')\"\n         [tabindex]=\"model.tabIndex\"\n         (change)=\"onChange($event)\">\n\n        <label *ngFor=\"let option of model.options$ | async\" class=\"btn\" role=\"button\"\n               [btnRadio]=\"option.value\"\n               [disabled]=\"option.disabled\"\n               [innerHTML]=\"option.label\"\n               [ngClass]=\"[getClass('element', 'option'), getClass('grid', 'option')]\"></label>\n    </div>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapRadioGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapRadioGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapRadioGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapRadioGroupComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapRadioGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapRadioGroupComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapRadioGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapRadioGroupComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapRadioGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapRadioGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapRadioGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapRatingComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapRatingComponent, _super);
        function DynamicNGxBootstrapRatingComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapRatingComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-rating",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <rating [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [max]=\"model.max\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [readonly]=\"model.getAdditional('readonly', false)\"\n            (onHover)=\"onCustomEvent($event, 'onHover')\"\n            (onLeave)=\"onCustomEvent($event, 'onLeave')\"></rating>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapRatingComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapRatingComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapRatingComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapRatingComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapRatingComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapRatingComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapRatingComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapRatingComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapRatingComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapRatingComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapRatingComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapSelectComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapSelectComponent, _super);
        function DynamicNGxBootstrapSelectComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapSelectComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-select",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <select class=\"form-control\"\n            [class.is-invalid]=\"showErrorMessages\"\n            [compareWith]=\"model.compareWithFn\"\n            [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [name]=\"model.name\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [required]=\"model.required\"\n            [tabindex]=\"model.tabIndex\"\n            (blur)=\"onBlur($event)\"\n            (change)=\"onChange($event)\"\n            (focus)=\"onFocus($event)\">\n\n        <option *ngFor=\"let option of model.options$ | async\"\n                [disabled]=\"option.disabled\"\n                [ngValue]=\"option.value\">{{ option.label }}</option>\n\n    </select>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapSelectComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapSelectComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapSelectComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapSelectComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapSelectComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapSelectComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapSelectComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapSelectComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapSelectComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapSelectComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapSelectComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapTextAreaComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapTextAreaComponent, _super);
        function DynamicNGxBootstrapTextAreaComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapTextAreaComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-textarea",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <textarea class=\"form-control\"\n              [class.is-invalid]=\"showErrorMessages\"\n              [cols]=\"model.cols\"\n              [formControlName]=\"model.id\"\n              [id]=\"elementId\"\n              [maxlength]=\"model.maxLength\"\n              [minlength]=\"model.minLength\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\"\n              [placeholder]=\"model.placeholder\"\n              [readonly]=\"model.readOnly\"\n              [required]=\"model.required\"\n              [rows]=\"model.rows\"\n              [spellcheck]=\"model.spellCheck\"\n              [tabindex]=\"model.tabIndex\"\n              [wrap]=\"model.wrap\"\n              (blur)=\"onBlur($event)\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"></textarea>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapTextAreaComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapTextAreaComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicNGxBootstrapTextAreaComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapTextAreaComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapTextAreaComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapTextAreaComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapTextAreaComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapTextAreaComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapTextAreaComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapTextAreaComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapTextAreaComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapTimePickerComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapTimePickerComponent, _super);
        function DynamicNGxBootstrapTimePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapTimePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-timepicker",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <timepicker [arrowkeys]=\"model.getAdditional('arrowkeys', true)\"\n                [formControlName]=\"model.id\"\n                [hourStep]=\"model.getAdditional('hourStep', 1)\"\n                [id]=\"elementId\"\n                [max]=\"model.max\"\n                [min]=\"model.min\"\n                [mousewheel]=\"model.getAdditional('mousewheel', true)\"\n                [minuteStep]=\"model.getAdditional('minuteStep', 1)\"\n                [ngClass]=\"getClass('element', 'control')\"\n                [secondsStep]=\"model.getAdditional('secondsStep', 1)\"\n                [showMeridian]=\"model.meridian\"\n                [showSeconds]=\"model.showSeconds\"\n                [showSpinners]=\"model.getAdditional('spinners', true)\"></timepicker>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapTimePickerComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicNGxBootstrapTimePickerComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            bsTimePicker: [{ type: core.ViewChild, args: [timepicker.TimepickerComponent, { static: true },] }]
        };
        return DynamicNGxBootstrapTimePickerComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.focus;
        /** @type {?} */
        DynamicNGxBootstrapTimePickerComponent.prototype.bsTimePicker;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapTimePickerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapTimePickerComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapFormControlContainerComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapFormControlContainerComponent, _super);
        function DynamicNGxBootstrapFormControlContainerComponent(componentFactoryResolver, layoutService, validationService, componentService, relationService) {
            var _this = _super.call(this, componentFactoryResolver, layoutService, validationService, componentService, relationService) || this;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.componentService = componentService;
            _this.relationService = relationService;
            _this.asBootstrapFormGroup = true;
            _this.context = null;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(DynamicNGxBootstrapFormControlContainerComponent.prototype, "componentType", {
            get: /**
             * @return {?}
             */
            function () {
                return this.componentService.getCustomComponentType(this.model) || bootstrapUIFormControlMapFn(this.model);
            },
            enumerable: true,
            configurable: true
        });
        DynamicNGxBootstrapFormControlContainerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-form-control",
                        template: "<div [class.form-group]=\"(model.type !== 'GROUP' && asBootstrapFormGroup) || getClass('element', 'container').includes('form-group')\"\n     [formGroup]=\"group\"\n     [ngClass]=\"['ng-dynamic-forms-'+model.type.toLowerCase(), getClass('element', 'container'), getClass('grid', 'container')]\">\n\n    <label *ngIf=\"!isCheckbox && hasLabel\"\n           [for]=\"elementId\"\n           [innerHTML]=\"model.label\"\n           [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label>\n\n    <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: model\"></ng-container>\n\n    <div [ngClass]=\"getClass('grid', 'control')\">\n\n        <ng-container #componentViewContainer></ng-container>\n\n        <small *ngIf=\"hasHint\" class=\"text-muted\" [innerHTML]=\"hint\" [ngClass]=\"getClass('element', 'hint')\"></small>\n\n        <div *ngIf=\"showErrorMessages\" [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\">\n            <small *ngFor=\"let message of errorMessages\" class=\"invalid-feedback d-block\">{{ message }}</small>\n        </div>\n\n    </div>\n\n    <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: model\"></ng-container>\n\n    <ng-content></ng-content>\n\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapFormControlContainerComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService },
            { type: core$1.DynamicFormComponentService },
            { type: core$1.DynamicFormRelationService }
        ]; };
        DynamicNGxBootstrapFormControlContainerComponent.propDecorators = {
            contentTemplateList: [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] }],
            inputTemplateList: [{ type: core.Input, args: ["templates",] }],
            asBootstrapFormGroup: [{ type: core.Input }],
            context: [{ type: core.Input }],
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            customEvent: [{ type: core.Output, args: ["bsEvent",] }],
            componentViewContainerRef: [{ type: core.ViewChild, args: ["componentViewContainer", {
                            read: core.ViewContainerRef,
                            static: true
                        },] }]
        };
        return DynamicNGxBootstrapFormControlContainerComponent;
    }(core$1.DynamicFormControlContainerComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.contentTemplateList;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.inputTemplateList;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.asBootstrapFormGroup;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.context;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.group;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.layout;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.model;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.focus;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.customEvent;
        /** @type {?} */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.componentViewContainerRef;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.componentFactoryResolver;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.validationService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.componentService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormControlContainerComponent.prototype.relationService;
    }
    /**
     * @param {?} model
     * @return {?}
     */
    function bootstrapUIFormControlMapFn(model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return DynamicNGxBootstrapFormArrayComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return DynamicNGxBootstrapCheckboxComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
                return DynamicNGxBootstrapCheckboxGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return DynamicNGxBootstrapDatePickerComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return DynamicNGxBootstrapFormGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return DynamicNGxBootstrapInputComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return DynamicNGxBootstrapRadioGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RATING:
                return DynamicNGxBootstrapRatingComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return DynamicNGxBootstrapSelectComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return DynamicNGxBootstrapTextAreaComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TIMEPICKER:
                return DynamicNGxBootstrapTimePickerComponent;
            default:
                return null;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicNGxBootstrapFormComponent = /** @class */ (function (_super) {
        __extends(DynamicNGxBootstrapFormComponent, _super);
        function DynamicNGxBootstrapFormComponent(formService, layoutService) {
            var _this = _super.call(this, formService, layoutService) || this;
            _this.formService = formService;
            _this.layoutService = layoutService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            return _this;
        }
        DynamicNGxBootstrapFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-ngx-bootstrap-form",
                        template: "<dynamic-ngx-bootstrap-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\"\n                                    [group]=\"formGroup\"\n                                    [hidden]=\"model.hidden\"\n                                    [layout]=\"formLayout\"\n                                    [model]=\"model\"\n                                    [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\"\n                                    [templates]=\"templates\"\n                                    (blur)=\"onEvent($event, 'blur')\"\n                                    (change)=\"onEvent($event, 'change')\"\n                                    (focus)=\"onEvent($event, 'focus')\"\n                                    (bsEvent)=\"onEvent($event, 'custom')\"></dynamic-ngx-bootstrap-form-control>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicNGxBootstrapFormComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormService },
            { type: core$1.DynamicFormLayoutService }
        ]; };
        DynamicNGxBootstrapFormComponent.propDecorators = {
            formGroup: [{ type: core.Input, args: ["group",] }],
            formModel: [{ type: core.Input, args: ["model",] }],
            formLayout: [{ type: core.Input, args: ["layout",] }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            customEvent: [{ type: core.Output, args: ["bsEvent",] }],
            templates: [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] }],
            components: [{ type: core.ViewChildren, args: [DynamicNGxBootstrapFormControlContainerComponent,] }]
        };
        return DynamicNGxBootstrapFormComponent;
    }(core$1.DynamicFormComponent));
    if (false) {
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.formGroup;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.formModel;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.formLayout;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.blur;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.change;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.focus;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.customEvent;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.templates;
        /** @type {?} */
        DynamicNGxBootstrapFormComponent.prototype.components;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormComponent.prototype.formService;
        /**
         * @type {?}
         * @protected
         */
        DynamicNGxBootstrapFormComponent.prototype.layoutService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicFormsNGxBootstrapUIModule = /** @class */ (function () {
        function DynamicFormsNGxBootstrapUIModule() {
        }
        DynamicFormsNGxBootstrapUIModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            datepicker.BsDatepickerModule,
                            buttons.ButtonsModule,
                            rating.RatingModule,
                            timepicker.TimepickerModule,
                            angular2TextMask.TextMaskModule,
                            core$1.DynamicFormsCoreModule
                        ],
                        declarations: [
                            DynamicNGxBootstrapCheckboxComponent,
                            DynamicNGxBootstrapCheckboxGroupComponent,
                            DynamicNGxBootstrapDatePickerComponent,
                            DynamicNGxBootstrapFormArrayComponent,
                            DynamicNGxBootstrapFormComponent,
                            DynamicNGxBootstrapFormControlContainerComponent,
                            DynamicNGxBootstrapFormGroupComponent,
                            DynamicNGxBootstrapInputComponent,
                            DynamicNGxBootstrapRadioGroupComponent,
                            DynamicNGxBootstrapRatingComponent,
                            DynamicNGxBootstrapSelectComponent,
                            DynamicNGxBootstrapTextAreaComponent,
                            DynamicNGxBootstrapTimePickerComponent
                        ],
                        entryComponents: [
                            DynamicNGxBootstrapCheckboxComponent,
                            DynamicNGxBootstrapCheckboxGroupComponent,
                            DynamicNGxBootstrapDatePickerComponent,
                            DynamicNGxBootstrapFormArrayComponent,
                            DynamicNGxBootstrapFormGroupComponent,
                            DynamicNGxBootstrapInputComponent,
                            DynamicNGxBootstrapRadioGroupComponent,
                            DynamicNGxBootstrapRatingComponent,
                            DynamicNGxBootstrapSelectComponent,
                            DynamicNGxBootstrapTextAreaComponent,
                            DynamicNGxBootstrapTimePickerComponent
                        ],
                        exports: [
                            core$1.DynamicFormsCoreModule,
                            DynamicNGxBootstrapCheckboxComponent,
                            DynamicNGxBootstrapCheckboxGroupComponent,
                            DynamicNGxBootstrapDatePickerComponent,
                            DynamicNGxBootstrapFormArrayComponent,
                            DynamicNGxBootstrapFormComponent,
                            DynamicNGxBootstrapFormControlContainerComponent,
                            DynamicNGxBootstrapFormGroupComponent,
                            DynamicNGxBootstrapInputComponent,
                            DynamicNGxBootstrapRadioGroupComponent,
                            DynamicNGxBootstrapRatingComponent,
                            DynamicNGxBootstrapSelectComponent,
                            DynamicNGxBootstrapTextAreaComponent,
                            DynamicNGxBootstrapTimePickerComponent
                        ]
                    },] }
        ];
        return DynamicFormsNGxBootstrapUIModule;
    }());

    exports.DynamicFormsNGxBootstrapUIModule = DynamicFormsNGxBootstrapUIModule;
    exports.DynamicNGxBootstrapCheckboxComponent = DynamicNGxBootstrapCheckboxComponent;
    exports.DynamicNGxBootstrapCheckboxGroupComponent = DynamicNGxBootstrapCheckboxGroupComponent;
    exports.DynamicNGxBootstrapDatePickerComponent = DynamicNGxBootstrapDatePickerComponent;
    exports.DynamicNGxBootstrapFormArrayComponent = DynamicNGxBootstrapFormArrayComponent;
    exports.DynamicNGxBootstrapFormComponent = DynamicNGxBootstrapFormComponent;
    exports.DynamicNGxBootstrapFormControlContainerComponent = DynamicNGxBootstrapFormControlContainerComponent;
    exports.DynamicNGxBootstrapFormGroupComponent = DynamicNGxBootstrapFormGroupComponent;
    exports.DynamicNGxBootstrapInputComponent = DynamicNGxBootstrapInputComponent;
    exports.DynamicNGxBootstrapRadioGroupComponent = DynamicNGxBootstrapRadioGroupComponent;
    exports.DynamicNGxBootstrapRatingComponent = DynamicNGxBootstrapRatingComponent;
    exports.DynamicNGxBootstrapSelectComponent = DynamicNGxBootstrapSelectComponent;
    exports.DynamicNGxBootstrapTextAreaComponent = DynamicNGxBootstrapTextAreaComponent;
    exports.DynamicNGxBootstrapTimePickerComponent = DynamicNGxBootstrapTimePickerComponent;
    exports.bootstrapUIFormControlMapFn = bootstrapUIFormControlMapFn;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ui-ngx-bootstrap.umd.js.map
